#include "qwayland-custom.h"

QT_BEGIN_NAMESPACE

namespace QtWayland {
    qt_example_extension::qt_example_extension(struct ::wl_registry *registry, int id, int version)
    {
        init(registry, id, version);
    }

    qt_example_extension::qt_example_extension(struct ::qt_example_extension *obj)
        : m_qt_example_extension(obj)
    {
        init_listener();
    }

    qt_example_extension::qt_example_extension()
        : m_qt_example_extension(0)
    {
    }

    qt_example_extension::~qt_example_extension()
    {
    }

    void qt_example_extension::init(struct ::wl_registry *registry, int id, int version)
    {
        m_qt_example_extension = static_cast<struct ::qt_example_extension *>(wl_registry_bind(registry, id, &qt_example_extension_interface, version));
        init_listener();
    }

    void qt_example_extension::init(struct ::qt_example_extension *obj)
    {
        m_qt_example_extension = obj;
        init_listener();
    }

    bool qt_example_extension::isInitialized() const
    {
        return m_qt_example_extension != 0;
    }

    const struct wl_interface *qt_example_extension::interface()
    {
        return &::qt_example_extension_interface;
    }

    void qt_example_extension::register_surface(struct ::wl_surface *surface)
    {
        qt_example_extension_register_surface(
            m_qt_example_extension,
            surface);
    }

    void qt_example_extension::bounce(struct ::wl_surface *surface, uint32_t duration)
    {
        qt_example_extension_bounce(
            m_qt_example_extension,
            surface,
            duration);
    }

    void qt_example_extension::spin(struct ::wl_surface *surface, uint32_t duration)
    {
        qt_example_extension_spin(
            m_qt_example_extension,
            surface,
            duration);
    }

    void qt_example_extension::example_extension_close(struct ::wl_surface *)
    {
    }

    void qt_example_extension::handle_close(
        void *data,
        struct ::qt_example_extension *object,
        struct ::wl_surface *surface)
    {
        Q_UNUSED(object);
        static_cast<qt_example_extension *>(data)->example_extension_close(
            surface);
    }

    void qt_example_extension::example_extension_set_font_size(struct ::wl_surface *, uint32_t )
    {
    }

    void qt_example_extension::handle_set_font_size(
        void *data,
        struct ::qt_example_extension *object,
        struct ::wl_surface *surface,
        uint32_t pixel_size)
    {
        Q_UNUSED(object);
        static_cast<qt_example_extension *>(data)->example_extension_set_font_size(
            surface,
            pixel_size);
    }

    void qt_example_extension::example_extension_set_window_decoration(uint32_t )
    {
    }

    void qt_example_extension::handle_set_window_decoration(
        void *data,
        struct ::qt_example_extension *object,
        uint32_t state)
    {
        Q_UNUSED(object);
        static_cast<qt_example_extension *>(data)->example_extension_set_window_decoration(
            state);
    }

    const struct qt_example_extension_listener qt_example_extension::m_qt_example_extension_listener = {
        qt_example_extension::handle_close,
        qt_example_extension::handle_set_font_size,
        qt_example_extension::handle_set_window_decoration
    };

    void qt_example_extension::init_listener()
    {
        qt_example_extension_add_listener(m_qt_example_extension, &m_qt_example_extension_listener, this);
    }
}

QT_END_NAMESPACE
